/*
 * generated by Xtext 2.22.0
 */
package tdt4250.ra.services;

import com.google.inject.Inject;
import com.google.inject.Singleton;
import java.util.List;
import org.eclipse.xtext.Alternatives;
import org.eclipse.xtext.Assignment;
import org.eclipse.xtext.CrossReference;
import org.eclipse.xtext.Grammar;
import org.eclipse.xtext.GrammarUtil;
import org.eclipse.xtext.Group;
import org.eclipse.xtext.Keyword;
import org.eclipse.xtext.ParserRule;
import org.eclipse.xtext.RuleCall;
import org.eclipse.xtext.TerminalRule;
import org.eclipse.xtext.common.services.TerminalsGrammarAccess;
import org.eclipse.xtext.service.AbstractElementFinder;
import org.eclipse.xtext.service.GrammarProvider;

@Singleton
public class RaxGrammarAccess extends AbstractElementFinder.AbstractGrammarElementFinder {
	
	public class DepartmentElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "tdt4250.ra.Rax.Department");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Assignment cShortNameAssignment_0 = (Assignment)cGroup.eContents().get(0);
		private final RuleCall cShortNameIDTerminalRuleCall_0_0 = (RuleCall)cShortNameAssignment_0.eContents().get(0);
		private final Keyword cHyphenMinusKeyword_1 = (Keyword)cGroup.eContents().get(1);
		private final Assignment cNameAssignment_2 = (Assignment)cGroup.eContents().get(2);
		private final RuleCall cNameSTRINGTerminalRuleCall_2_0 = (RuleCall)cNameAssignment_2.eContents().get(0);
		private final Keyword cPersonsKeyword_3 = (Keyword)cGroup.eContents().get(3);
		private final Assignment cStaffAssignment_4 = (Assignment)cGroup.eContents().get(4);
		private final RuleCall cStaffPersonParserRuleCall_4_0 = (RuleCall)cStaffAssignment_4.eContents().get(0);
		private final Keyword cCoursesKeyword_5 = (Keyword)cGroup.eContents().get(5);
		private final Assignment cCoursesAssignment_6 = (Assignment)cGroup.eContents().get(6);
		private final RuleCall cCoursesCourseParserRuleCall_6_0 = (RuleCall)cCoursesAssignment_6.eContents().get(0);
		
		//Department:
		//	shortName=ID '-' name=STRING 'Persons:'
		//	staff+=Person*
		//	'Courses:'
		//	courses+=Course*;
		@Override public ParserRule getRule() { return rule; }
		
		//shortName=ID '-' name=STRING 'Persons:' staff+=Person* 'Courses:' courses+=Course*
		public Group getGroup() { return cGroup; }
		
		//shortName=ID
		public Assignment getShortNameAssignment_0() { return cShortNameAssignment_0; }
		
		//ID
		public RuleCall getShortNameIDTerminalRuleCall_0_0() { return cShortNameIDTerminalRuleCall_0_0; }
		
		//'-'
		public Keyword getHyphenMinusKeyword_1() { return cHyphenMinusKeyword_1; }
		
		//name=STRING
		public Assignment getNameAssignment_2() { return cNameAssignment_2; }
		
		//STRING
		public RuleCall getNameSTRINGTerminalRuleCall_2_0() { return cNameSTRINGTerminalRuleCall_2_0; }
		
		//'Persons:'
		public Keyword getPersonsKeyword_3() { return cPersonsKeyword_3; }
		
		//staff+=Person*
		public Assignment getStaffAssignment_4() { return cStaffAssignment_4; }
		
		//Person
		public RuleCall getStaffPersonParserRuleCall_4_0() { return cStaffPersonParserRuleCall_4_0; }
		
		//'Courses:'
		public Keyword getCoursesKeyword_5() { return cCoursesKeyword_5; }
		
		//courses+=Course*
		public Assignment getCoursesAssignment_6() { return cCoursesAssignment_6; }
		
		//Course
		public RuleCall getCoursesCourseParserRuleCall_6_0() { return cCoursesCourseParserRuleCall_6_0; }
	}
	public class CourseElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "tdt4250.ra.Rax.Course");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Assignment cCodeAssignment_0 = (Assignment)cGroup.eContents().get(0);
		private final RuleCall cCodeIDTerminalRuleCall_0_0 = (RuleCall)cCodeAssignment_0.eContents().get(0);
		private final Keyword cHyphenMinusKeyword_1 = (Keyword)cGroup.eContents().get(1);
		private final Assignment cNameAssignment_2 = (Assignment)cGroup.eContents().get(2);
		private final RuleCall cNameSTRINGTerminalRuleCall_2_0 = (RuleCall)cNameAssignment_2.eContents().get(0);
		private final Group cGroup_3 = (Group)cGroup.eContents().get(3);
		private final Keyword cRequiresKeyword_3_0 = (Keyword)cGroup_3.eContents().get(0);
		private final Assignment cRolesAssignment_3_1 = (Assignment)cGroup_3.eContents().get(1);
		private final RuleCall cRolesRoleParserRuleCall_3_1_0 = (RuleCall)cRolesAssignment_3_1.eContents().get(0);
		private final Group cGroup_3_2 = (Group)cGroup_3.eContents().get(2);
		private final Keyword cCommaKeyword_3_2_0 = (Keyword)cGroup_3_2.eContents().get(0);
		private final Assignment cRolesAssignment_3_2_1 = (Assignment)cGroup_3_2.eContents().get(1);
		private final RuleCall cRolesRoleParserRuleCall_3_2_1_0 = (RuleCall)cRolesAssignment_3_2_1.eContents().get(0);
		private final Keyword cProvidedByKeyword_3_3 = (Keyword)cGroup_3.eContents().get(3);
		private final Assignment cResourceAllocationsAssignment_3_4 = (Assignment)cGroup_3.eContents().get(4);
		private final RuleCall cResourceAllocationsResourceAllocationParserRuleCall_3_4_0 = (RuleCall)cResourceAllocationsAssignment_3_4.eContents().get(0);
		
		//Course:
		//	code=ID '-'? name=STRING ('requires' roles+=Role (',' roles+=Role)*
		//	'provided-by' resourceAllocations+=ResourceAllocation+)?;
		@Override public ParserRule getRule() { return rule; }
		
		//code=ID '-'? name=STRING ('requires' roles+=Role (',' roles+=Role)* 'provided-by'
		//resourceAllocations+=ResourceAllocation+)?
		public Group getGroup() { return cGroup; }
		
		//code=ID
		public Assignment getCodeAssignment_0() { return cCodeAssignment_0; }
		
		//ID
		public RuleCall getCodeIDTerminalRuleCall_0_0() { return cCodeIDTerminalRuleCall_0_0; }
		
		//'-'?
		public Keyword getHyphenMinusKeyword_1() { return cHyphenMinusKeyword_1; }
		
		//name=STRING
		public Assignment getNameAssignment_2() { return cNameAssignment_2; }
		
		//STRING
		public RuleCall getNameSTRINGTerminalRuleCall_2_0() { return cNameSTRINGTerminalRuleCall_2_0; }
		
		//('requires' roles+=Role (',' roles+=Role)* 'provided-by' resourceAllocations+=ResourceAllocation+)?
		public Group getGroup_3() { return cGroup_3; }
		
		//'requires'
		public Keyword getRequiresKeyword_3_0() { return cRequiresKeyword_3_0; }
		
		//roles+=Role
		public Assignment getRolesAssignment_3_1() { return cRolesAssignment_3_1; }
		
		//Role
		public RuleCall getRolesRoleParserRuleCall_3_1_0() { return cRolesRoleParserRuleCall_3_1_0; }
		
		//(',' roles+=Role)*
		public Group getGroup_3_2() { return cGroup_3_2; }
		
		//','
		public Keyword getCommaKeyword_3_2_0() { return cCommaKeyword_3_2_0; }
		
		//roles+=Role
		public Assignment getRolesAssignment_3_2_1() { return cRolesAssignment_3_2_1; }
		
		//Role
		public RuleCall getRolesRoleParserRuleCall_3_2_1_0() { return cRolesRoleParserRuleCall_3_2_1_0; }
		
		//'provided-by'
		public Keyword getProvidedByKeyword_3_3() { return cProvidedByKeyword_3_3; }
		
		//resourceAllocations+=ResourceAllocation+
		public Assignment getResourceAllocationsAssignment_3_4() { return cResourceAllocationsAssignment_3_4; }
		
		//ResourceAllocation
		public RuleCall getResourceAllocationsResourceAllocationParserRuleCall_3_4_0() { return cResourceAllocationsResourceAllocationParserRuleCall_3_4_0; }
	}
	public class ResourceAllocationElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "tdt4250.ra.Rax.ResourceAllocation");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Assignment cPersonAssignment_0 = (Assignment)cGroup.eContents().get(0);
		private final CrossReference cPersonPersonCrossReference_0_0 = (CrossReference)cPersonAssignment_0.eContents().get(0);
		private final RuleCall cPersonPersonID_OR_STRINGParserRuleCall_0_0_1 = (RuleCall)cPersonPersonCrossReference_0_0.eContents().get(1);
		private final Keyword cIsKeyword_1 = (Keyword)cGroup.eContents().get(1);
		private final Assignment cFactorAssignment_2 = (Assignment)cGroup.eContents().get(2);
		private final RuleCall cFactorFactorParserRuleCall_2_0 = (RuleCall)cFactorAssignment_2.eContents().get(0);
		private final Keyword cAsKeyword_3 = (Keyword)cGroup.eContents().get(3);
		private final Assignment cRoleAssignment_4 = (Assignment)cGroup.eContents().get(4);
		private final CrossReference cRoleRoleCrossReference_4_0 = (CrossReference)cRoleAssignment_4.eContents().get(0);
		private final RuleCall cRoleRoleIDTerminalRuleCall_4_0_1 = (RuleCall)cRoleRoleCrossReference_4_0.eContents().get(1);
		
		//ResourceAllocation:
		//	person=[Person|ID_OR_STRING] 'is' factor=Factor 'as' role=[Role];
		@Override public ParserRule getRule() { return rule; }
		
		//person=[Person|ID_OR_STRING] 'is' factor=Factor 'as' role=[Role]
		public Group getGroup() { return cGroup; }
		
		//person=[Person|ID_OR_STRING]
		public Assignment getPersonAssignment_0() { return cPersonAssignment_0; }
		
		//[Person|ID_OR_STRING]
		public CrossReference getPersonPersonCrossReference_0_0() { return cPersonPersonCrossReference_0_0; }
		
		//ID_OR_STRING
		public RuleCall getPersonPersonID_OR_STRINGParserRuleCall_0_0_1() { return cPersonPersonID_OR_STRINGParserRuleCall_0_0_1; }
		
		//'is'
		public Keyword getIsKeyword_1() { return cIsKeyword_1; }
		
		//factor=Factor
		public Assignment getFactorAssignment_2() { return cFactorAssignment_2; }
		
		//Factor
		public RuleCall getFactorFactorParserRuleCall_2_0() { return cFactorFactorParserRuleCall_2_0; }
		
		//'as'
		public Keyword getAsKeyword_3() { return cAsKeyword_3; }
		
		//role=[Role]
		public Assignment getRoleAssignment_4() { return cRoleAssignment_4; }
		
		//[Role]
		public CrossReference getRoleRoleCrossReference_4_0() { return cRoleRoleCrossReference_4_0; }
		
		//ID
		public RuleCall getRoleRoleIDTerminalRuleCall_4_0_1() { return cRoleRoleIDTerminalRuleCall_4_0_1; }
	}
	public class FactorElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "tdt4250.ra.Rax.Factor");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final RuleCall cINTTerminalRuleCall_0 = (RuleCall)cGroup.eContents().get(0);
		private final Keyword cFullStopKeyword_1 = (Keyword)cGroup.eContents().get(1);
		private final RuleCall cINTTerminalRuleCall_2 = (RuleCall)cGroup.eContents().get(2);
		
		//Factor ecore::EFloat:
		//	INT '.' INT;
		@Override public ParserRule getRule() { return rule; }
		
		//INT '.' INT
		public Group getGroup() { return cGroup; }
		
		//INT
		public RuleCall getINTTerminalRuleCall_0() { return cINTTerminalRuleCall_0; }
		
		//'.'
		public Keyword getFullStopKeyword_1() { return cFullStopKeyword_1; }
		
		//INT
		public RuleCall getINTTerminalRuleCall_2() { return cINTTerminalRuleCall_2; }
	}
	public class RoleElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "tdt4250.ra.Rax.Role");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Assignment cNameAssignment_0 = (Assignment)cGroup.eContents().get(0);
		private final RuleCall cNameIDTerminalRuleCall_0_0 = (RuleCall)cNameAssignment_0.eContents().get(0);
		private final Keyword cForKeyword_1 = (Keyword)cGroup.eContents().get(1);
		private final Assignment cFactorAssignment_2 = (Assignment)cGroup.eContents().get(2);
		private final RuleCall cFactorFactorParserRuleCall_2_0 = (RuleCall)cFactorAssignment_2.eContents().get(0);
		
		//Role:
		//	name=ID 'for' factor=Factor;
		@Override public ParserRule getRule() { return rule; }
		
		//name=ID 'for' factor=Factor
		public Group getGroup() { return cGroup; }
		
		//name=ID
		public Assignment getNameAssignment_0() { return cNameAssignment_0; }
		
		//ID
		public RuleCall getNameIDTerminalRuleCall_0_0() { return cNameIDTerminalRuleCall_0_0; }
		
		//'for'
		public Keyword getForKeyword_1() { return cForKeyword_1; }
		
		//factor=Factor
		public Assignment getFactorAssignment_2() { return cFactorAssignment_2; }
		
		//Factor
		public RuleCall getFactorFactorParserRuleCall_2_0() { return cFactorFactorParserRuleCall_2_0; }
	}
	public class ID_OR_STRINGElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "tdt4250.ra.Rax.ID_OR_STRING");
		private final Alternatives cAlternatives = (Alternatives)rule.eContents().get(1);
		private final RuleCall cIDTerminalRuleCall_0 = (RuleCall)cAlternatives.eContents().get(0);
		private final RuleCall cSTRINGTerminalRuleCall_1 = (RuleCall)cAlternatives.eContents().get(1);
		
		//ID_OR_STRING:
		//	ID | STRING;
		@Override public ParserRule getRule() { return rule; }
		
		//ID | STRING
		public Alternatives getAlternatives() { return cAlternatives; }
		
		//ID
		public RuleCall getIDTerminalRuleCall_0() { return cIDTerminalRuleCall_0; }
		
		//STRING
		public RuleCall getSTRINGTerminalRuleCall_1() { return cSTRINGTerminalRuleCall_1; }
	}
	public class PersonElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "tdt4250.ra.Rax.Person");
		private final Assignment cNameAssignment = (Assignment)rule.eContents().get(1);
		private final RuleCall cNameID_OR_STRINGParserRuleCall_0 = (RuleCall)cNameAssignment.eContents().get(0);
		
		//Person:
		//	name=ID_OR_STRING;
		@Override public ParserRule getRule() { return rule; }
		
		//name=ID_OR_STRING
		public Assignment getNameAssignment() { return cNameAssignment; }
		
		//ID_OR_STRING
		public RuleCall getNameID_OR_STRINGParserRuleCall_0() { return cNameID_OR_STRINGParserRuleCall_0; }
	}
	
	
	private final DepartmentElements pDepartment;
	private final CourseElements pCourse;
	private final ResourceAllocationElements pResourceAllocation;
	private final FactorElements pFactor;
	private final RoleElements pRole;
	private final ID_OR_STRINGElements pID_OR_STRING;
	private final PersonElements pPerson;
	
	private final Grammar grammar;
	
	private final TerminalsGrammarAccess gaTerminals;

	@Inject
	public RaxGrammarAccess(GrammarProvider grammarProvider,
			TerminalsGrammarAccess gaTerminals) {
		this.grammar = internalFindGrammar(grammarProvider);
		this.gaTerminals = gaTerminals;
		this.pDepartment = new DepartmentElements();
		this.pCourse = new CourseElements();
		this.pResourceAllocation = new ResourceAllocationElements();
		this.pFactor = new FactorElements();
		this.pRole = new RoleElements();
		this.pID_OR_STRING = new ID_OR_STRINGElements();
		this.pPerson = new PersonElements();
	}
	
	protected Grammar internalFindGrammar(GrammarProvider grammarProvider) {
		Grammar grammar = grammarProvider.getGrammar(this);
		while (grammar != null) {
			if ("tdt4250.ra.Rax".equals(grammar.getName())) {
				return grammar;
			}
			List<Grammar> grammars = grammar.getUsedGrammars();
			if (!grammars.isEmpty()) {
				grammar = grammars.iterator().next();
			} else {
				return null;
			}
		}
		return grammar;
	}
	
	@Override
	public Grammar getGrammar() {
		return grammar;
	}
	
	
	public TerminalsGrammarAccess getTerminalsGrammarAccess() {
		return gaTerminals;
	}

	
	//Department:
	//	shortName=ID '-' name=STRING 'Persons:'
	//	staff+=Person*
	//	'Courses:'
	//	courses+=Course*;
	public DepartmentElements getDepartmentAccess() {
		return pDepartment;
	}
	
	public ParserRule getDepartmentRule() {
		return getDepartmentAccess().getRule();
	}
	
	//Course:
	//	code=ID '-'? name=STRING ('requires' roles+=Role (',' roles+=Role)*
	//	'provided-by' resourceAllocations+=ResourceAllocation+)?;
	public CourseElements getCourseAccess() {
		return pCourse;
	}
	
	public ParserRule getCourseRule() {
		return getCourseAccess().getRule();
	}
	
	//ResourceAllocation:
	//	person=[Person|ID_OR_STRING] 'is' factor=Factor 'as' role=[Role];
	public ResourceAllocationElements getResourceAllocationAccess() {
		return pResourceAllocation;
	}
	
	public ParserRule getResourceAllocationRule() {
		return getResourceAllocationAccess().getRule();
	}
	
	//Factor ecore::EFloat:
	//	INT '.' INT;
	public FactorElements getFactorAccess() {
		return pFactor;
	}
	
	public ParserRule getFactorRule() {
		return getFactorAccess().getRule();
	}
	
	//Role:
	//	name=ID 'for' factor=Factor;
	public RoleElements getRoleAccess() {
		return pRole;
	}
	
	public ParserRule getRoleRule() {
		return getRoleAccess().getRule();
	}
	
	//ID_OR_STRING:
	//	ID | STRING;
	public ID_OR_STRINGElements getID_OR_STRINGAccess() {
		return pID_OR_STRING;
	}
	
	public ParserRule getID_OR_STRINGRule() {
		return getID_OR_STRINGAccess().getRule();
	}
	
	//Person:
	//	name=ID_OR_STRING;
	public PersonElements getPersonAccess() {
		return pPerson;
	}
	
	public ParserRule getPersonRule() {
		return getPersonAccess().getRule();
	}
	
	//terminal ID:
	//	'^'? ('a'..'z' | 'A'..'Z' | '_') ('a'..'z' | 'A'..'Z' | '_' | '0'..'9')*;
	public TerminalRule getIDRule() {
		return gaTerminals.getIDRule();
	}
	
	//terminal INT returns ecore::EInt:
	//	'0'..'9'+;
	public TerminalRule getINTRule() {
		return gaTerminals.getINTRule();
	}
	
	//terminal STRING:
	//	'"' ('\\' . | !('\\' | '"'))* '"' |
	//	"'" ('\\' . | !('\\' | "'"))* "'";
	public TerminalRule getSTRINGRule() {
		return gaTerminals.getSTRINGRule();
	}
	
	//terminal ML_COMMENT:
	//	'/*'->'*/';
	public TerminalRule getML_COMMENTRule() {
		return gaTerminals.getML_COMMENTRule();
	}
	
	//terminal SL_COMMENT:
	//	'//' !('\n' | '\r')* ('\r'? '\n')?;
	public TerminalRule getSL_COMMENTRule() {
		return gaTerminals.getSL_COMMENTRule();
	}
	
	//terminal WS:
	//	' ' | '\t' | '\r' | '\n'+;
	public TerminalRule getWSRule() {
		return gaTerminals.getWSRule();
	}
	
	//terminal ANY_OTHER:
	//	.;
	public TerminalRule getANY_OTHERRule() {
		return gaTerminals.getANY_OTHERRule();
	}
}
